#include "Camera.h"
#include "OgreCamera.h"
#include "MovingObject.h"

Camera::Camera(Ogre::Camera *renderCamera) : mRenderCamera(renderCamera), mObjectToTrack(NULL)
{
	mCurrentFollowDistance = 50;
	mCurrentFollowHeight  = 30;
}

void Camera::Think(float time)
{
	if (mObjectToTrack != NULL)
	{
		Ogre::Vector3 trackPos = mObjectToTrack->getPosition();
		Ogre::Vector3 cameraPos;

		Ogre::Vector3 delta = mObjectToTrack->getFacing() * -mCurrentFollowDistance;

		delta.y = mCurrentFollowHeight;

		

		mRenderCamera->setPosition(trackPos + delta);
		mRenderCamera->lookAt(trackPos);
	}
}


Camera::~Camera(void)
{
}
