#pragma once
#include "OgreVector3.h"
#include "OgreQuaternion.h"
#include "OgreAxisAlignedBox.h"

class OBB
{
public:
	OBB();
	OBB(Ogre::AxisAlignedBox b);
    OBB(Ogre::AxisAlignedBox b, Ogre::Vector3 position, Ogre::Quaternion orientation);
    ~OBB(void);

    void setPosition(Ogre::Vector3 newPosition);
    void translate(Ogre::Vector3 deltaPosition);
    void setOrientation(Ogre::Quaternion orentation);
    bool collides(const OBB &other, Ogre::Vector3 &MTD) const;
    bool collides(const OBB *other, Ogre::Vector3 &MTD) const;
    void setScale(Ogre::Vector3 scale);
	void resetAABB(Ogre::AxisAlignedBox b);
	Ogre::AxisAlignedBox getAABB() { resetAABBandPoints(); return mAABB;}
	

protected:
    Ogre::AxisAlignedBox mAABB;
    Ogre::Vector3 mPosition;
    Ogre::Quaternion mOrientation;
    Ogre::Vector3 mScale;
    void resetAABBandPoints();
    std::vector<Ogre::Vector3> mPointsLocal;
    std::vector<Ogre::Vector3> mPointsGlobal;
    std::vector<Ogre::Vector3> mNormals;
    void setPoints(Ogre::AxisAlignedBox b);
    void setNormals();

};

