#include "TriggerArea.h"
#include "MovingObject.h"
#include "LuaWrapper.h"

TriggerArea::TriggerArea(Ogre::Vector3 center, Ogre::Vector3 size, Ogre::SceneManager *sm)
{
	mOnEnterLuaCallback = "";
	mOnExitLuaCallback == "";

	mTriggerArea = new MovingObject("MyCube.mesh", "trigger", sm);
	mTriggerArea->setScale(size);
	mTriggerArea->setPosition(center);
	mTriggerArea->setMaterial("BlueSemiTrans2");
}


TriggerArea::~TriggerArea(void)
{
}

void TriggerArea::setOnEnterCallback(std::string luaCallbackCode)
{
	mOnEnterLuaCallback = luaCallbackCode;

}

void TriggerArea::setOnExitCallback(std::string luaCallbackCode)
{
	mOnExitLuaCallback = luaCallbackCode;
}



void TriggerArea::setPosition(Ogre::Vector3 position)
{
	mTriggerArea->setPosition(position);
}
void TriggerArea::setSize(Ogre::Vector3 size)
{
	mTriggerArea->setScale(size);
}
void TriggerArea::setOrientation(Ogre::Quaternion orientation)
{
	mTriggerArea->setOrientation(orientation);
}


void TriggerArea::setVisible(bool isVisible)
{

	mTriggerArea->setVisible(isVisible);
}


void TriggerArea::checkObject(MovingObject *obj)
{
	Ogre::Vector3 mtd;
	if (obj->getOBB()->collides(mTriggerArea->getOBB(), mtd))
	{
		if (mObjectsInside.find(obj) == mObjectsInside.end())
		{
			if (mOnEnterLuaCallback.length() > 0)
			{
				std::string command = std::string("local triggerObject = '") + obj->name() + std::string("'") + mOnEnterLuaCallback;
				LuaWrapper::getSingleton()->doString(command.c_str());
			}
			mObjectsInside.insert(obj);
		}

	} 
	else
	{
		if (mObjectsInside.find(obj) != mObjectsInside.end())
		{
			if (mOnExitLuaCallback.length() > 0)
			{
				std::string command = std::string("local triggerObject = '") + obj->name() + std::string("'") + mOnExitLuaCallback;
				LuaWrapper::getSingleton()->doString(command.c_str());
			}

			mObjectsInside.erase(obj);

		}
	}


}
