#pragma once
#include "OgreVector3.h"
class MovingObject;
namespace Ogre {

class SceneManager;
}
class TriggerArea
{
public:
	TriggerArea(Ogre::Vector3 center, Ogre::Vector3 size, Ogre::SceneManager *sm);

	void setOnEnterCallback(std::string luaCallbackCode);

	void setOnExitCallback(std::string luaCallbackCode);

	void setVisible(bool isVisible);

	void checkObject(MovingObject *obj);

	void setPosition(Ogre::Vector3 position);
	void setSize(Ogre::Vector3 size);
	void setOrientation(Ogre::Quaternion orienation);

	bool obejctsInside() { return mObjectsInside.size() > 0; }


	~TriggerArea(void);

protected:
	MovingObject *mTriggerArea;
	// TODO:  Change this to a list / vector of all objects inside
	std::set<MovingObject *>mObjectsInside;
	std::string mOnEnterLuaCallback;
	std::string mOnExitLuaCallback;
};

