#include "OgreVector3.h"


namespace Ogre {
    class SceneNode;
    class SceneManager;
}

class MovingObject;
class InputHandler;
class TriggerArea;

class World

{
public:
	
    World(Ogre::SceneManager *sceneManager, InputHandler *ih);
    
    void Think(float time);

    MovingObject *createMovingObject(std::string meshName, std::string objectName);
    bool removeMovingObject(std::string objectName);
	MovingObject *createStaticObject(std::string meshName, std::string objectName);

    void setPosition(std::string objectName, Ogre::Vector3 newPosition);
	void setVelocity(std::string objectName, Ogre::Vector3 velocity);
	void setScale(std::string objectname, Ogre::Vector3 newScale);


	MovingObject *getMovingObject(std::string name);
	Ogre::Vector3 getPosition(std::string objectName);

	MovingObject *getPlayer() { return mPlayer; }
    

	TriggerArea *addTriggerArea(std::string name, Ogre::Vector3 location, Ogre::Vector3 size);
	TriggerArea *addTriggerArea(std::string name);


	TriggerArea *getTriggerArea(std::string name);
	bool setTriggerAreaOnEnter(std::string name, std::string luaScrpt);
	bool setTriggerAreaOnExit(std::string name, std::string luaScrpt);

	bool setTriggerAreaLocation(std::string name, Ogre::Vector3 location);
	bool setTriggerAreaSize(std::string name, Ogre::Vector3 size);

	bool setTriggerAreaVisible(std::string name, bool isVisible);

	

	void Setup();
protected:
	 
    // You are going to want to keep track of your entities, in some kind 
    //  of list, map, table, set, or combination of lists, maps tables & sets.

    // For our example, we will just have a single instance variable.  You should
    //  Replace this with something else!

	void handlePlayerInput(float time);
    Ogre::SceneManager *mSceneManager; 

	std::map<std::string, MovingObject *> mMovingObjects;
	std::map<std::string, MovingObject *> mStaticObjects;


	std::map<std::string, TriggerArea *> mTriggerAreas;


	InputHandler *mInputHandler;
	MovingObject *mPlayer;

};
